#! /usr/bin/env ruby

#0 102 "Hometown"
#1 103 "Redrock Ridge"
#2 104 "Atlantica"
#3 105 "Rocky Pass"
#4 106 "Country Woods"
#5 107 "Lost Canyons"
#6 108 "Aquatica"
#7 109 "Summit"
#8 110 "Empire City"

module NFS3Text
  N = 1955
  TRACK_MAP = {
    'home' => 102, 'hometown' => 102,
    'redrock' => 103,
    'atlantica' => 104,
    'rocky' => 105,
    'country' => 106,
    'lost' => 107,
    'aquatica' => 108,
    'summit' => 109,
    'empire' => 110,
  }.freeze

  def self.read buf
    buf.force_encoding Encoding::ISO_8859_1
    fail unless buf.unpack1('V') == N*4
    ary = buf[N*4..].split "\0"
    fail unless ary.size == N
    ary
  end

  def self.write ary, io
    off = N*4
    ofm = ary.map do |m|
      res = off
      off += m.bytesize + 1
      res
    end

    io.write ofm.pack 'V*'
    io.write ary.join "\0"
    io.write "\0"
  end
end

return unless __FILE__ == $0

$stdin.binmode
ary = NFS3Text.read $stdin.read

# if ENV['DUMP']
  require 'ap'
  ap ary.map {|x| x.encode Encoding::UTF_8 }
  exit
# end

# ARGV.each_slice 2 do |o,v|
#   ary[Integer o] = v.encode Encoding::ISO_8859_1
# end

# $stdout.binmode
# NFS3Text.write ary, $stdout
